## GORange GORange |

## Functions

int | go_range_average ()
int | go_range_averagel ()
int | go_range_averageD ()
int | go_range_constant ()
int | go_range_constantl ()
int | go_range_constantD ()
int | go_range_decreasing ()
int | go_range_decreasingl ()
int | go_range_decreasingD ()
int | go_range_devsq ()
int | go_range_devsql ()
int | go_range_devsqD ()
int | go_range_fractile_inter ()
int | go_range_fractile_interl ()
int | go_range_fractile_interD ()
int | go_range_fractile_inter_nonconst ()
int | go_range_fractile_inter_nonconstl ()
int | go_range_fractile_inter_nonconstD ()
int | go_range_fractile_inter_sorted ()
int | go_range_fractile_inter_sortedl ()
int | go_range_fractile_inter_sortedD ()
int | go_range_increasing ()
int | go_range_increasingl ()
int | go_range_increasingD ()
int | go_range_max ()
int | go_range_maxl ()
int | go_range_maxD ()
int | go_range_maxabs ()
int | go_range_maxabsl ()
int | go_range_maxabsD ()
int | go_range_median_inter ()
int | go_range_median_interl ()
int | go_range_median_interD ()
int | go_range_median_inter_nonconst ()
int | go_range_median_inter_nonconstl ()
int | go_range_median_inter_nonconstD ()
int | go_range_median_inter_sorted ()
int | go_range_median_inter_sortedl ()
int | go_range_median_inter_sortedD ()
int | go_range_min ()
int | go_range_minl ()
int | go_range_minD ()
double * | go_range_sort ()
long double * | go_range_sortl ()
_Decimal64 * | go_range_sortD ()
int | go_range_sum ()
int | go_range_suml ()
int | go_range_sumD ()
int | go_range_sumsq ()
int | go_range_sumsql ()
int | go_range_sumsqD ()
int | go_range_vary_uniformly ()
int | go_range_vary_uniformlyl ()
int | go_range_vary_uniformlyD ()

## Description

## Functions

### go_range_average ()

    int
    go_range_average (double const *xs,
                      int n,
                      double *res);

The average of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_averagel ()

    int
    go_range_averagel (long double const *xs,
                       int n,
                       long double *res);

The average of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_averageD ()

    int
    go_range_averageD (_Decimal64 const *xs,
                       int n,
                       _Decimal64 *res);

The average of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_constant ()

    int
    go_range_constant (double const *xs,
                       int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is constant, 0 otherwise.

### go_range_constantl ()

    int
    go_range_constantl (long double const *xs,
                        int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is constant, 0 otherwise.

### go_range_constantD ()

    int
    go_range_constantD (_Decimal64 const *xs,
                        int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is constant, 0 otherwise.

### go_range_decreasing ()

    int
    go_range_decreasing (double const *xs,
                         int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is decreasing, 0 otherwise.

### go_range_decreasingl ()

    int
    go_range_decreasingl (long double const *xs,
                          int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is decreasing, 0 otherwise.

### go_range_decreasingD ()

    int
    go_range_decreasingD (_Decimal64 const *xs,
                          int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is decreasing, 0 otherwise.

### go_range_devsq ()

    int
    go_range_devsq (double const *xs,
                    int n,
                    double *res);

The sum of the input values deviation from the mean will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_devsql ()

    int
    go_range_devsql (long double const *xs,
                     int n,
                     long double *res);

The sum of the input values deviation from the mean will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_devsqD ()

    int
    go_range_devsqD (_Decimal64 const *xs,
                     int n,
                     _Decimal64 *res);

The sum of the input values deviation from the mean will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_fractile_inter ()

    int
    go_range_fractile_inter (double const *xs,
                             int n,
                             double *res,
                             double f);

This function computes the interpolated fractile given by `f` and stores it in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_fractile_interl ()

    int
    go_range_fractile_interl (long double const *xs,
                              int n,
                              long double *res,
                              long double f);

This function computes the interpolated fractile given by `f` and stores it in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_fractile_interD ()

    int
    go_range_fractile_interD (_Decimal64 const *xs,
                              int n,
                              _Decimal64 *res,
                              _Decimal64 f);

This function computes the interpolated fractile given by `f` and stores it in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_fractile_inter_nonconst ()

    int
    go_range_fractile_inter_nonconst (double *xs,
                                      int n,
                                      double *res,
                                      double f);

This function computes the interpolated fractile given by `f` and stores it in `res` . Unlike go_range_fractile_inter, this function may reorder the elements of `xs` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_fractile_inter_nonconstl ()

    int
    go_range_fractile_inter_nonconstl (long double *xs,
                                       int n,
                                       long double *res,
                                       long double f);

This function computes the interpolated fractile given by `f` and stores it in `res` . Unlike go_range_fractile_inter, this function may reorder the elements of `xs` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_fractile_inter_nonconstD ()

    int
    go_range_fractile_inter_nonconstD (_Decimal64 *xs,
                                       int n,
                                       _Decimal64 *res,
                                       _Decimal64 f);

This function computes the interpolated fractile given by `f` and stores it in `res` . Unlike go_range_fractile_inter, this function may reorder the elements of `xs` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_fractile_inter_sorted ()

    int
    go_range_fractile_inter_sorted (double const *xs,
                                    int n,
                                    double *res,
                                    double f);

This function computes the interpolated fractile given by `f` and stores it in `res` .

#### Parameters

xs | values, which must be sorted. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_fractile_inter_sortedl ()

    int
    go_range_fractile_inter_sortedl (long double const *xs,
                                     int n,
                                     long double *res,
                                     long double f);

This function computes the interpolated fractile given by `f` and stores it in `res` .

#### Parameters

xs | values, which must be sorted. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_fractile_inter_sortedD ()

    int
    go_range_fractile_inter_sortedD (_Decimal64 const *xs,
                                     int n,
                                     _Decimal64 *res,
                                     _Decimal64 f);

This function computes the interpolated fractile given by `f` and stores it in `res` .

#### Parameters

xs | values, which must be sorted. | [array length=n]
n | number of values |
res | result. | [out]
f | fractile |

#### Returns

0 unless an error occurred.

### go_range_increasing ()

    int
    go_range_increasing (double const *xs,
                         int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is increasing, 0 otherwise.

### go_range_increasingl ()

    int
    go_range_increasingl (long double const *xs,
                          int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is increasing, 0 otherwise.

### go_range_increasingD ()

    int
    go_range_increasingD (_Decimal64 const *xs,
                          int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is increasing, 0 otherwise.

### go_range_max ()

    int
    go_range_max (double const *xs,
                  int n,
                  double *res);

The maximum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_maxl ()

    int
    go_range_maxl (long double const *xs,
                   int n,
                   long double *res);

The maximum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_maxD ()

    int
    go_range_maxD (_Decimal64 const *xs,
                   int n,
                   _Decimal64 *res);

The maximum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_maxabs ()

    int
    go_range_maxabs (double const *xs,
                     int n,
                     double *res);

The maximum of the absolute values of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_maxabsl ()

    int
    go_range_maxabsl (long double const *xs,
                      int n,
                      long double *res);

The maximum of the absolute values of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_maxabsD ()

    int
    go_range_maxabsD (_Decimal64 const *xs,
                      int n,
                      _Decimal64 *res);

The maximum of the absolute values of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_inter ()

    int
    go_range_median_inter (double const *xs,
                           int n,
                           double *res);

This function computes the interpolated median and stores it in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_interl ()

    int
    go_range_median_interl (long double const *xs,
                            int n,
                            long double *res);

This function computes the interpolated median and stores it in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_interD ()

    int
    go_range_median_interD (_Decimal64 const *xs,
                            int n,
                            _Decimal64 *res);

This function computes the interpolated median and stores it in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_inter_nonconst ()

    int
    go_range_median_inter_nonconst (double *xs,
                                    int n,
                                    double *res);

This function computes the interpolated median and stores it in `res` . Unlike go_range_median_inter, this function may reorder the elements of `xs` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_inter_nonconstl ()

    int
    go_range_median_inter_nonconstl (long double *xs,
                                     int n,
                                     long double *res);

This function computes the interpolated median and stores it in `res` . Unlike go_range_median_inter, this function may reorder the elements of `xs` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_inter_nonconstD ()

    int
    go_range_median_inter_nonconstD (_Decimal64 *xs,
                                     int n,
                                     _Decimal64 *res);

This function computes the interpolated median and stores it in `res` . Unlike go_range_median_inter, this function may reorder the elements of `xs` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_inter_sorted ()

    int
    go_range_median_inter_sorted (double const *xs,
                                  int n,
                                  double *res);

This function computes the interpolated median and stores it in `res` .

#### Parameters

xs | values, which must be sorted. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_inter_sortedl ()

    int
    go_range_median_inter_sortedl (long double const *xs,
                                   int n,
                                   long double *res);

This function computes the interpolated median and stores it in `res` .

#### Parameters

xs | values, which must be sorted. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_median_inter_sortedD ()

    int
    go_range_median_inter_sortedD (_Decimal64 const *xs,
                                   int n,
                                   _Decimal64 *res);

This function computes the interpolated median and stores it in `res` .

#### Parameters

xs | values, which must be sorted. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_min ()

    int
    go_range_min (double const *xs,
                  int n,
                  double *res);

The minimum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_minl ()

    int
    go_range_minl (long double const *xs,
                   int n,
                   long double *res);

The minimum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_minD ()

    int
    go_range_minD (_Decimal64 const *xs,
                   int n,
                   _Decimal64 *res);

The minimum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_sort ()

    double *
    go_range_sort (double const *xs,
                   int n);

This function creates a sorted copy of `xs` .

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

a sorted copy of `xs` .

[array length=n][transfer full]

### go_range_sortl ()

    long double *
    go_range_sortl (long double const *xs,
                    int n);

This function creates a sorted copy of `xs` .

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

a sorted copy of `xs` .

[array length=n][transfer full]

### go_range_sortD ()

    _Decimal64 *
    go_range_sortD (_Decimal64 const *xs,
                    int n);

This function creates a sorted copy of `xs` .

[skip]

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

introspection cannot handle this one.

[type void]

### go_range_sum ()

    int
    go_range_sum (double const *xs,
                  int n,
                  double *res);

The arithmetic sum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_suml ()

    int
    go_range_suml (long double const *xs,
                   int n,
                   long double *res);

The arithmetic sum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_sumD ()

    int
    go_range_sumD (_Decimal64 const *xs,
                   int n,
                   _Decimal64 *res);

The arithmetic sum of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_sumsq ()

    int
    go_range_sumsq (double const *xs,
                    int n,
                    double *res);

The arithmetic sum of the squares of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_sumsql ()

    int
    go_range_sumsql (long double const *xs,
                     int n,
                     long double *res);

The arithmetic sum of the squares of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_sumsqD ()

    int
    go_range_sumsqD (_Decimal64 const *xs,
                     int n,
                     _Decimal64 *res);

The arithmetic sum of the squares of the input values will be stored in `res` .

#### Parameters

xs | values. | [array length=n]
n | number of values |
res | result. | [out]

#### Returns

0 unless an error occurred.

### go_range_vary_uniformly ()

    int
    go_range_vary_uniformly (double const *xs,
                             int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is either decreasing or increasing, 0 otherwise.

### go_range_vary_uniformlyl ()

    int
    go_range_vary_uniformlyl (long double const *xs,
                              int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is either decreasing or increasing, 0 otherwise.

### go_range_vary_uniformlyD ()

    int
    go_range_vary_uniformlyD (_Decimal64 const *xs,
                              int n);

#### Parameters

xs | values. | [array length=n]
n | number of values |

#### Returns

1 if range is either decreasing or increasing, 0 otherwise.